variables:
  SCSREL: "1.09"
  REVIEW_CONTAINER_NAME: review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA} # eg: review-knocat-branch600-ca3ec109
  REVIEW_REGISTRY_IMAGE: $CI_REGISTRY_IMAGE/review
  PROD_REGISTRY_IMAGE: $CI_REGISTRY_IMAGE/prod
  DOCKER_HOST: "tcp://localhost:2375"
  DOCKER_TLS_CERTDIR: ""  # https://gitlab.com/gitlab-org/gitlab-runner/issues/4501


stages:
  - deploy_review_service
  - deploy_prod_service

deploy_review_service:
  stage: deploy_review_service
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v0.1.0"
  variables:
    GIT_STRATEGY: none
  environment:
    name: review/review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}
    url: http://www.review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}.scsuk.net
    on_stop: stop_review
  script:
    - echo "Start the review deployment $REVIEW_CONTAINER_NAME"
    - echo kubectl run $REVIEW_CONTAINER_NAME --image=gitlab.scsuk.net:5005/scs-systems/ext_registry/grafana/grafana:6.2.5 -n web --env="GF_SECURITY_ADMIN_PASSWORD=admintmp" --env="GF_AUTH_ANONYMOUS_ENABLED=true" --env="GF_AUTH_ANONYMOUS_ORG_NAME=Main Org." --env="GF_AUTH_ANONYMOUS_ORG_ROLE=Viewer"
    - kubectl run $REVIEW_CONTAINER_NAME --image=gitlab.scsuk.net:5005/scs-systems/ext_registry/grafana/grafana:6.2.5 -n web --env="GF_SECURITY_ADMIN_PASSWORD=admintmp" --env="GF_AUTH_ANONYMOUS_ENABLED=true" --env="GF_AUTH_ANONYMOUS_ORG_NAME=Main Org." --env="GF_AUTH_ANONYMOUS_ORG_ROLE=Viewer"
    - echo kubectl expose deployment $REVIEW_CONTAINER_NAME --port 80 --target-port=3000 -n web
    - kubectl expose deployment $REVIEW_CONTAINER_NAME --port 80 --target-port=3000 -n web
    - sleep 10
    - kubectl get deployments -n web $REVIEW_CONTAINER_NAME
    - kubectl get services -n web $REVIEW_CONTAINER_NAME
    - kubectl get pods -o wide -n web
  except:
     - master

stop_review:
  stage: deploy_review_service
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v0.1.0"
  variables:
    GIT_STRATEGY: none
  script:
    - echo kubectl delete service $REVIEW_CONTAINER_NAME -n web
    - kubectl delete service $REVIEW_CONTAINER_NAME -n web
    - echo kubectl delete deployment $REVIEW_CONTAINER_NAME -n web
    - kubectl delete deployment $REVIEW_CONTAINER_NAME -n web
  when: manual
  environment:
    name: review/review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}
    url: http://www.review-${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}.scsuk.net
    action: stop
  except:
     - master

deploy_prod_service:
  stage: deploy_prod_service
  image: "registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v0.1.0"
  script:
    - echo ./deploy_prod_service.sh ${CI_PROJECT_NAME}
    - ./deploy_prod_service.sh ${CI_PROJECT_NAME}
  environment:
    name: production
    url: http://www.grafana.scsuk.net
  when: manual
  only:
     - master

